# Generated by Django 4.1 on 2024-03-04 15:28

from django.db import migrations, models


def populate_result_preview(apps, schema_editor):
    # Populate the new result preview field
    TaskExec = apps.get_model("toosimpleq", "TaskExec")
    TaskExec.objects.filter(result__isnull=False).update(
        result_preview="*preview not generated*"
    )


class Migration(migrations.Migration):
    dependencies = [
        ("toosimpleq", "0014_alter_workerstatus_exit_code"),
    ]

    operations = [
        migrations.AddField(
            model_name="taskexec",
            name="result_preview",
            field=models.CharField(
                blank=True, editable=False, max_length=255, null=True
            ),
        ),
        migrations.RunPython(populate_result_preview),
    ]
